Package: dotCall64
Type: Package
Title: Enhanced Foreign Function Interface Supporting Long Vectors
Version: 1.1-1
Date: 2023-11-28
Authors@R: c(person("Kaspar", "Moesinger", role = c("aut"),
    email = "kaspar.moesinger@gmail.com"), 
    person("Florian", "Gerber", role = c("aut"),
    email = "flora.fauna.gerber@gmail.com",
    comment = c(ORCID = "0000-0001-8545-5263")),
    person("Reinhard", "Furrer", role = c("cre", "ctb"),
    email = "reinhard.furrer@math.uzh.ch",
    comment = c(ORCID = "0000-0002-6319-2332")))
Description: Provides .C64(), which is an enhanced version of .C()
    and .Fortran() from the foreign function interface. .C64() supports long
    vectors, arguments of type 64-bit integer, and provides a mechanism to
    avoid unnecessary copies of read-only and write-only arguments. This
    makes it a convenient and fast interface to C/C++ and Fortran code.
License: GPL (>= 2)
URL: https://git.math.uzh.ch/reinhard.furrer/dotCall64
BugReports: https://git.math.uzh.ch/reinhard.furrer/dotCall64/-/issues
Depends: R (>= 3.1)
Suggests: microbenchmark, RhpcBLASctl, RColorBrewer, roxygen2, spam,
        testthat,
Collate: 'vector_dc.R' 'dotCall64.R' 'zzz.R'
RoxygenNote: 7.1.1
NeedsCompilation: yes
Packaged: 2023-11-28 10:54:16 UTC; furrer
Author: Kaspar Moesinger [aut],
  Florian Gerber [aut] (<https://orcid.org/0000-0001-8545-5263>),
  Reinhard Furrer [cre, ctb] (<https://orcid.org/0000-0002-6319-2332>)
Maintainer: Reinhard Furrer <reinhard.furrer@math.uzh.ch>
Repository: CRAN
Date/Publication: 2023-11-28 11:30:02 UTC
Built: R 4.2.3; aarch64-apple-darwin20; 2023-11-28 12:22:24 UTC; unix
Archs: dotCall64.so.dSYM

Package: dotCall64
Type: Package
Title: Enhanced Foreign Function Interface Supporting Long Vectors
Version: 1.2
Date: 2024-10-03
Authors@R: c(person("Kaspar", "Moesinger", role = c("aut"),
    email = "kaspar.moesinger@gmail.com"), 
    person("Florian", "Gerber", role = c("aut"),
    email = "flora.fauna.gerber@gmail.com",
    comment = c(ORCID = "0000-0001-8545-5263")),
    person("Reinhard", "Furrer", role = c("cre", "ctb"),
    email = "reinhard.furrer@uzh.ch",
    comment = c(ORCID = "0000-0002-6319-2332")))
Description: Provides .C64(), which is an enhanced version of .C()
    and .Fortran() from the foreign function interface. .C64() supports long
    vectors, arguments of type 64-bit integer, and provides a mechanism to
    avoid unnecessary copies of read-only and write-only arguments. This
    makes it a convenient and fast interface to C/C++ and Fortran code.
License: GPL (>= 2)
URL: https://git.math.uzh.ch/reinhard.furrer/dotCall64
BugReports: https://git.math.uzh.ch/reinhard.furrer/dotCall64/-/issues
Depends: R (>= 4.0)
Suggests: microbenchmark, RhpcBLASctl, RColorBrewer, roxygen2, spam,
        testthat,
Collate: 'vector_dc.R' 'dotCall64.R' 'zzz.R'
RoxygenNote: 7.2.3
NeedsCompilation: yes
Packaged: 2024-10-03 11:57:25 UTC; furrer
Author: Kaspar Moesinger [aut],
  Florian Gerber [aut] (<https://orcid.org/0000-0001-8545-5263>),
  Reinhard Furrer [cre, ctb] (<https://orcid.org/0000-0002-6319-2332>)
Maintainer: Reinhard Furrer <reinhard.furrer@uzh.ch>
Repository: CRAN
Date/Publication: 2024-10-04 17:10:05 UTC
Built: R 4.3.3; aarch64-apple-darwin20; 2025-01-25 21:47:16 UTC; unix
Archs: dotCall64.so.dSYM

c      https://stackoverflow.com/questions/3170239/fortran-integer4-vs-integer4-vs-integerkind-4


      subroutine get_f(input, index, output)
      double precision :: input(*), output(*)
      integer :: index
      output(1) = input(index)
      end

      subroutine get64_f(input, index, output)
      double precision :: input(*), output(*)
      integer (8) :: index  ! 64-bit integer on GFortran, differs with other compilers   
      output(1) = input(index)
      end

require("RhpcBLASctl"); omp_set_num_threads(1)
# to address:
# * checking tests ... [10s/1s] NOTE
#   Running ‘run-all.R’ [10s/1s]
#   Running R code in ‘run-all.R’ had CPU time 10.5 times elapsed time

library(testthat)
test_check('dotCall64')

#' dotCall64 - Extended Foreign Function Interface
#' 
#' \code{.C64} can be used to call compiled and loaded C/C++ functions and Fortran subroutines.
#' \code{.C64} is similar to \code{\link{.C}} and \code{\link{.Fortran}}, but
#' \enumerate{
#'    \item supports long vectors, i.e., vectors with more than \code{2^31-1} elements
#'    \item does the necessary castings to expose the R representation of "64-bit integers" (numeric vectors)
#' to 64-bit integer arguments of the compiled function. The latter are int64_t in C code and integer (kind = 8) in Fortran code
#'    \item provides a mechanism the control duplication of the R objects exposed to the compiled code
#'    \item checks if the provided R objects are of the expected types and coerces them if necessary
#' }
#' Compared to \code{\link{.C}}, \code{.C64} has the additional arguments \code{SIGNATURE}, \code{INTENT} and \code{VERBOSE}.
#' \code{SIGNATURE} specifies the types of the arguments of the compiled function.
#' \code{INTENT} indicates whether the compiled function "reads", "writes",
#' or "read and writes" to the R objects passed to the compiled function.
#' This information is then used to duplicate R objects if and only if necessary.
#' 
#' @param .NAME character vector of length 1. Name of the compiled function to be called.
#' @param SIGNATURE character vector of the same length as the number of arguments of the compiled function.
#' Accepted strings are \code{"double"}, \code{"integer"}, and \code{"int64"}.
#' They describe the signature of each argument of the compiled function.
#' @param ... arguments passed to the compiled function. One R object for each argument. Up to 65 arguments are supported.
#' @param INTENT character vector of the same length as the number of arguments of the compiled function.
#' Accepted strings are \code{"rw"}, \code{"r"}, and \code{"w"}, which indicate
#' whether the intent of the argument is "read and write", "read", or "write", respectively.
#' If the INTENT of an argument is \code{"rw"}, the R object is copied and the
#' compiled function receives a pointer to that copy.
#' If the INTENT of an R object is \code{"r"}, the compiled
#' function receives a pointer to the R object itself.
#' While this avoids copying and hence is more efficient in terms of speed and memory usage,
#' it is absolutely necessary that the compiled function does not alter the object,
#' since this corrupts the R object in the current R session.
#' When the INTENT is \code{"w"}, the corresponding input argument can be specified
#' with the function \code{\link{vector_dc}} or its shortcuts \code{\link{integer_dc}} and \code{\link{numeric_dc}}.
#' This avoids copying the passed R objects and hence is more efficient in terms of speed and memory usage.
#' By default, all arguments have INTENT \code{"rw"}.
#' @param NAOK logical vector of length 1. If \code{FALSE} (default), the presence of \code{NA}, \code{NaN}, and \code{Inf}
#' in the R objects passed through \code{...} results in an error.
#' If \code{TRUE}, \code{NA}, \code{NaN}, and \code{Inf} values are passed to the compiled function.
#' The used time to check arguments (if \code{FALSE}) is considerable for large vectors. 
#' @param PACKAGE character vector of length 1. Specifies where to search for the function given in \code{.NAME}. 
#' This is intended to add safety for packages,
#' which can use this argument to ensure that no other package can override their external symbols,
#' and also speeds up the search.
#' @param VERBOSE numeric vector of length 1. If \code{0}, no warnings are printed.
#' If \code{1}, warnings are printed, which help to improve the performance of the call.
#' If \code{2}, additional debug information is given as warnings.
#' The default value can be changed via the \code{dotCall64.verbose} option, which is set to \code{0} by default. 
#'  
#' @return  list of R objects similar to the list of arguments specified as \code{...} arguments.
#' The objects of the list reflect the changes made by the compiled C or Fortran function.
#'  
#' @references
#' F. Gerber, K. Moesinger, R. Furrer (2018),
#' dotCall64: An R package providing an efficient interface to compiled C, C++, and Fortran code supporting long vectors,
#' SoftwareX 7, 217-221,
#' https://doi.org/10.1016/j.softx.2018.06.002.
#'  
#' F. Gerber, K. Moesinger, and R. Furrer (2017),
#' Extending R packages to support 64-bit compiled code: An illustration with spam64 and GIMMS NDVI3g data,
#' Computer & Geoscience 104, 109-119,
#' https://doi.org/10.1016/j.cageo.2016.11.015.
#'
#' @examples
#' ## Consider the following C function, which is included
#' ## in the dotCall64 package:  
#' ## void get_c(double *input, int *index, double *output) {
#' ##     output[0] = input[index[0] - 1];
#' ## }
#' ##
#' ## We can use .C64() to call get_c() from R:
#' .C64("get_c", SIGNATURE = c("double", "integer", "double"),
#'      input = 1:10, index = 9, output = double(1))$output
#'
#' \dontrun{
#' ## 'input' can be a long vector
#' x_long <- double(2^31) ## requires 16 GB RAM
#' x_long[9] <- 9; x_long[2^31] <- -1
#' .C64("get_c", SIGNATURE = c("double", "integer", "double"),
#'      input = x_long, index = 9, output = double(1))$output
#'
#' ## Since 'index' is of type 'signed int' (a 32-bit integer),
#' ## it can only address the first 2^31-1 elements of 'input'.
#' ## To also address elements beyond 2^31-1, we change the
#' ## definition of the C function as follows:
#' ## #include <stdint.h>  //  for int64_t 
#' ## void get64_c(double *input, int64_t *index, double *output) {
#' ##     output[0] = input[index[0] - 1];
#' ## }
#' 
#' ## Now, we can use .C64() to call get64_c() from R.
#' .C64("get64_c", SIGNATURE = c("double", "int64", "double"),
#'      input = x_long, index = 2^31, output = double(1))$output
#' ## Note that 2^31 is of type double and .C64() casts it into an
#' ## int64_t type before calling the C function get64_c().
#'
#' ## The performance of the previous call can be improved by
#' ## setting additional arguments:
#' .C64("get64_c", SIGNATURE = c("double", "int64", "double"),
#'      x = x_long, i = 2^31, r = numeric_dc(1), INTENT = c("r", "r", "w"),
#'      NAOK = TRUE, PACKAGE = "dotCall64", VERBOSE = 0)$r
#' 
#'
#' ## Consider the same function defined in Fortran:
#' ##      subroutine get64_f(input, index, output)
#' ##      double precision :: input(*), output(*)
#' ##      integer (kind = 8) :: index  ! specific to GFortran
#' ##      output(1) = input(index)
#' ##      end
#' 
#' ## The function is provided in dotCall64 and can be called with
#' .C64("get64_f", SIGNATURE = c("double", "int64", "double"),
#'      input = x_long, index = 2^31, output = double(1))$output
#' }
#' @useDynLib dotCall64, .registration = TRUE
#' @export
#' @name dotCall64
.C64 <- function(.NAME, SIGNATURE, ..., INTENT = NULL, NAOK = FALSE,
                 PACKAGE = "", VERBOSE = getOption("dotCall64.verbose")) {
  .External("dC64", name = .NAME, SIGNATURE = SIGNATURE, ..., INTENT = INTENT, NAOK = NAOK,
            f.PACKAGE = PACKAGE, VERBOSE = VERBOSE, PACKAGE = "dotCall64")
    }

context("test-flow-left")

test_that("int64-double-rw", {
  a <- 2**32
  dc <- .C64("TEST_prod_int64", c("int64", "int64"),
             a = a, b = 2,
             PACKAGE = "dotCall64", VERBOSE = 1)
  dc_e <- list(a = 2**33, b = 2)
  expect_equal(lapply(dc, typeof), lapply(dc_e, typeof))      
  expect_equal(dc, dc_e)
  expect_identical(a, 2**32, label = "[modified R object]")

  expr <- expression(.C64("TEST_prod_int64", c("int64", "int64"),
                          a = a, b = 2,
                          PACKAGE = "dotCall64", VERBOSE = 2))
  expect_warning(eval(expr),
                 "alloc 1; coerce 0; dup 0;\ncast.in 1; cast.back 1")
})

test_that("int64-double-r", {
  a <- 2**32
  dc <- .C64("TEST_prod_int64", c("int64", "int64"),
             a = a, b = 2, INTENT = c("r", "rw"),
             PACKAGE = "dotCall64", VERBOSE = 1)
  dc_e <- list(a = NULL, b = 2)
  expect_equal(lapply(dc, typeof), lapply(dc_e, typeof))      
  expect_equal(dc, dc_e)
  expect_identical(a, 2**32, label = "[modified R object]")
  ## a not modified, because not in place double -> long int transition

  expr <- expression(.C64("TEST_prod_int64", c("int64", "int64"),
                          a = a, b = 2, INTENT = c("r", "rw"),
                          PACKAGE = "dotCall64", VERBOSE = 2))
  expect_warning(eval(expr),
                 "alloc 1; coerce 0; dup 0;\ncast.in 1; cast.back 0")
  expect_warning(eval(expr),
                 "alloc 1; coerce 0; dup 0;\ncast.in 1; cast.back 1")

})


test_that("int64-integer-rw", {
  a <- 5L
  expr <- expression(.C64("TEST_prod_int64", c("int64", "int64"),
                          a = a, b = 2L,
                          PACKAGE = "dotCall64", VERBOSE = 1))
  dc <- suppressWarnings(eval(expr))
  dc_e <- list(a = 10, b = 2)
  expect_equal(lapply(dc, typeof), lapply(dc_e, typeof))      
  expect_equal(dc, dc_e)
  expect_identical(a, 5L, label = "[modified R object]")
  expect_warning(eval(expr), "[dotCall64|wrong R object type]",
                 label = "[dotCall64|wrong R object type]")

  expr <- expression(.C64("TEST_prod_int64", c("int64", "int64"),
                          a = a, b = 2L,
                          PACKAGE = "dotCall64", VERBOSE = 2))
  expect_warning(eval(expr),
                 "alloc 1; coerce 0; dup 0;\ncast.in 1; cast.back 1")

})

test_that("int64-integer-r", {
  a <- 5L
  expr <- expression(.C64("TEST_prod_int64", c("int64", "int64"),
                          a = a, b = 2L, INTENT = c("r", "rw"),
                          PACKAGE = "dotCall64", VERBOSE = 1))
  dc <- suppressWarnings(eval(expr))
  dc_e <- list(a = NULL, b = 2)
  expect_equal(lapply(dc, typeof), lapply(dc_e, typeof))      
  expect_equal(dc, dc_e)
  expect_identical(a, 5L, label = "[modified R object]")
  ## a not modified, because not in place double -> long int transition
  expect_warning(eval(expr), "[dotCall64|wrong R object type]",
                 label = "[dotCall64|wrong R object type]")

  expr <- expression(.C64("TEST_prod_int64", c("int64", "int64"),
                          a = a, b = 2L, INTENT = c("r", "rw"),
                          PACKAGE = "dotCall64", VERBOSE = 2))
  expect_warning(eval(expr),
                 "alloc 1; coerce 0; dup 0;\ncast.in 1; cast.back 0")
  expect_warning(eval(expr),
                 "alloc 1; coerce 0; dup 0;\ncast.in 1; cast.back 1")

})


test_that("int64-complex-rw", {
  a <- 5+5i
  expr <- expression(.C64("TEST_prod_int64", c("int64", "int64"),
                          a = a, b = 2+2i,
                          PACKAGE = "dotCall64", VERBOSE = 1))
  dc <- suppressWarnings(eval(expr))
  dc_e <- list(a = 10, b = 2)
  expect_equal(lapply(dc, typeof), lapply(dc_e, typeof))      
  expect_equal(dc, dc_e)
  expect_identical(a, 5+5i, label = "[modified R object]")
  expect_warning(eval(expr), "[dotCall64|wrong R object type]",
                 label = "[dotCall64|wrong R object type]")

  expr <- expression(.C64("TEST_prod_int64", c("int64", "int64"),
                          a = a, b = 2+2i,
                          PACKAGE = "dotCall64", VERBOSE = 2))
  
  expect_warning(eval(expr),
                 "alloc 0; coerce 1; dup 0;\ncast.in 1; cast.back 1")

})

test_that("int64-complex-r", {
  a <- 5+5i
  expr <- expression(.C64("TEST_prod_int64", c("int64", "int64"),
                          a = a, b = 2+2i, INTENT = c("r", "rw"),
                          PACKAGE = "dotCall64", VERBOSE = 1))
  dc <- suppressWarnings(eval(expr))
  dc_e <- list(a = NULL, b = 2)
  expect_equal(lapply(dc, typeof), lapply(dc_e, typeof))      
  expect_equal(dc, dc_e)
  expect_identical(a, 5+5i, label = "[modified R object]")
  ## a not modified, because not in place double -> long int transition
  expect_warning(eval(expr), "[dotCall64|wrong R object type]",
                 label = "[dotCall64|wrong R object type]")

  expr <- expression(.C64("TEST_prod_int64", c("int64", "int64"),
                          a = a, b = 2+2i, INTENT = c("r", "rw"),
                          PACKAGE = "dotCall64", VERBOSE = 2))
    expect_warning(eval(expr),
                 "alloc 0; coerce 1; dup 0;\ncast.in 1; cast.back 0")

})

context("test-againstDotC")

test_that("int", {
    cc <- .C("TEST_times2_int",  a = 2L, r = integer(1),
             PACKAGE = "dotCall64")
    dc <- .C64("TEST_times2_int", c("int", "int"),  a = 2L, r = integer(1),
               INTENT = c("rw", "rw"),
               PACKAGE = "dotCall64")
    expect_equal(cc, dc, label = "[values]")
    expect_equal(lapply(cc, typeof), lapply(dc, typeof),
                 label = "[types]")
    })


test_that("double", {
    cc <- .C("TEST_times2_double",  a = 2.2, r = double(1),
             PACKAGE = "dotCall64")
    dc <- .C64("TEST_times2_double", c("double", "double"),
               a = 2.2, r = double(1),
               INTENT = c("rw", "rw"),
               PACKAGE = "dotCall64")
    expect_equal(cc, dc, label = "[values]")
    expect_equal(lapply(cc, typeof), lapply(dc, typeof),
                 label = "[types]")
    })

## --------------------
test_that("referenced-integer", {
    input <- 2L
    cc <- .C("TEST_times2_int",  a = input, r = input,
             PACKAGE = "dotCall64")
    dc <- .C64("TEST_times2_int", c("int", "int"),
               a = input, r = input,
               INTENT = c("rw", "rw"),
               PACKAGE = "dotCall64")
    expect_equal(cc, dc, label = "[values]")
    expect_equal(lapply(cc, typeof), lapply(dc, typeof),
                 label = "[types]")
    expect_identical(input, 2L)
})

test_that("referenced-double", {
    input <- 2.2
    cc <- .C("TEST_times2_double",  a = input, r = input,
             PACKAGE = "dotCall64")
    dc <- .C64("TEST_times2_double", c("double", "double"),
               a = input, r = input,
               INTENT = c("rw", "rw"),
               PACKAGE = "dotCall64")
    expect_equal(cc, dc, label = "[values]")
    expect_equal(lapply(cc, typeof), lapply(dc, typeof),
                 label = "[types]")
    expect_identical(input, 2.2)
})

context("test-flow-center")

test_that("double-double", {
  a <- 3.3
  dc <- .C64("TEST_prod_double", c("double", "double"),
             a = a, b = 2,
             PACKAGE = "dotCall64",
             VERBOSE = 1)
  dc_e <- list(a = 6.6, b = 2)
  expect_equal(lapply(dc, typeof), lapply(dc_e, typeof))
  expect_equal(dc, dc_e)
  expect_identical(a, 3.3, label = "[modified R object]")

  expr <- expression(.C64("TEST_prod_double",
                          c("double", "double"),
                          a = a, b = 2,
                          PACKAGE = "dotCall64",
                          VERBOSE = 2))
  expect_warning(eval(expr),
                 "alloc 0; coerce 0; dup 1;\ncast.in 0; cast.back 0;")
})


test_that("double-double-modifiedRead", {
  a <- 3.3
  dc <- .C64("TEST_prod_double", c("double", "double"),
             a = a, b = 2, INTENT = c("r", "rw"),
             PACKAGE = "dotCall64", VERBOSE = 1)
  dc_e <- list(a = NULL, b = 2)
  expect_equal(lapply(dc, typeof), lapply(dc_e, typeof))
  expect_equal(dc, dc_e)
  expect_identical(a, 6.6, label = "[modified R object]")

  expr <- expression(.C64("TEST_prod_double",
                          c("double", "double"),
                          a = a, b = 2,
                          INTENT = c("r", "rw"),
                          PACKAGE = "dotCall64",
                          VERBOSE = 2))
  expect_warning(eval(expr),
                 "alloc 0; coerce 0; dup 1;\ncast.in 0; cast.back 0;")
  expect_warning(eval(expr),
                 "alloc 0; coerce 0; dup 0;\ncast.in 0; cast.back 0;")
})


test_that("int-int", {
  a <- 3L
  dc <- .C64("TEST_prod_int", c("int", "int"),
             a = a, b = 2L,
             PACKAGE = "dotCall64", VERBOSE = 1)
  dc_e <- list(a = 6L, b = 2L)
  expect_equal(lapply(dc, typeof), lapply(dc_e, typeof))
  expect_equal(dc, dc_e)
  expect_identical(a, 3L, label = "[modified R object]")

  expr <- expression(.C64("TEST_prod_int",
                          c("int", "int"),
                          a = a, b = 2L,
                          PACKAGE = "dotCall64",
                          VERBOSE = 2))
  expect_warning(eval(expr),
                 "alloc 0; coerce 0; dup 1;\ncast.in 0; cast.back 0")
})


test_that("int-int-modifiedRead", {
  a <- 3L
  dc <- .C64("TEST_prod_int", c("int", "int"),
             a = a, b = 2L, INTENT = c("r", "rw"),
             PACKAGE = "dotCall64", VERBOSE = 1)
  dc_e <- list(a = NULL, b = 2L)
  expect_equal(lapply(dc, typeof), lapply(dc_e, typeof))
  expect_equal(dc, dc_e)
  expect_identical(a, 6L, label = "[modified R object]")

  expr <- expression(.C64("TEST_prod_int",
                          c("int", "int"),
                          a = a, b = 2L,
                          INTENT = c("r", "rw"),
                          PACKAGE = "dotCall64",
                          VERBOSE = 2))
  expect_warning(eval(expr),
                 "alloc 0; coerce 0; dup 0;\ncast.in 0; cast.back 0")
  expect_warning(eval(expr),
                 "alloc 0; coerce 0; dup 1;\ncast.in 0; cast.back 0")
})


test_that("int-double-rw", {
  a <- 3
  expr <- expression(.C64("TEST_prod_int", c("int", "int"),
                          a = a, b = 2,
                          PACKAGE = "dotCall64", VERBOSE = 1))
  dc <- suppressWarnings(eval(expr))
  dc_e <- list(a = 6L, b = 2L)
  expect_equal(lapply(dc, typeof), lapply(dc_e, typeof))
  expect_equal(dc, dc_e)
  expect_identical(a, 3, label = "[modified R object]")
  expect_warning(eval(expr), "[dotCall64|wrong R object type]",
                 label = "[dotCall64|wrong R object type]")

  expr <- expression(.C64("TEST_prod_int",
                          c("int", "int"),
                          a = a, b = 2,
                          PACKAGE = "dotCall64",
                          VERBOSE = 2))
  expect_warning(eval(expr),
                 "alloc 0; coerce 1; dup 0;\ncast.in 0; cast.back 0")
})


test_that("int-double-r", {
  a <- 3
  expr <- expression(.C64("TEST_prod_int", c("int", "int"),
                          a = a, b = 2, INTENT = c("r", "rw"),
                          PACKAGE = "dotCall64", VERBOSE = 1))
  dc <- suppressWarnings(eval(expr))
  dc_e <- list(a = NULL, b = 2L)
  expect_equal(lapply(dc, typeof), lapply(dc_e, typeof))
  expect_equal(dc, dc_e)
  expect_identical(a, 3, label = "[modified R object]")
  expect_warning(eval(expr), "[dotCall64|wrong R object type]",
                 label = "[dotCall64|wrong R object type]")

  expr <- expression(.C64("TEST_prod_int",
                          c("int", "int"),
                          a = a, b = 2,
                          INTENT = c("r", "rw"),
                          PACKAGE = "dotCall64",
                          VERBOSE = 2))
  expect_warning(eval(expr),
                 "alloc 0; coerce 1; dup 0;\ncast.in 0; cast.back 0")
})


test_that("double-int-rw", {
  a <- 3L
  expr <- expression(.C64("TEST_prod_double", c("double", "double"),
                          a = a, b = 2L,
                          PACKAGE = "dotCall64", VERBOSE = 1))
  dc <- suppressWarnings(eval(expr))
  dc_e <- list(a = 6, b = 2)
  expect_equal(lapply(dc, typeof), lapply(dc_e, typeof))
  expect_equal(dc, dc_e)
  expect_identical(a, 3L, label = "[modified R object]")
  expect_warning(eval(expr), "[dotCall64|wrong R object type]",
                 label = "[dotCall64|wrong R object type]")

  expr <- expression(.C64("TEST_prod_double",
                          c("double", "double"),
                          a = a, b = 2L,
                          PACKAGE = "dotCall64",
                          VERBOSE = 2))
  expect_warning(eval(expr),
                 "alloc 0; coerce 1; dup 0;\ncast.in 0; cast.back 0")
})


test_that("double-int-r", {
  a <- 3L
  expr <- expression(.C64("TEST_prod_double", c("double", "double"),
                          a = a, b = 2L, INTENT = c("r", "rw"),
                          PACKAGE = "dotCall64", VERBOSE = 1))
  dc <- suppressWarnings(eval(expr))
  dc_e <- list(a = NULL, b = 2)
  expect_equal(lapply(dc, typeof), lapply(dc_e, typeof))
  expect_equal(dc, dc_e)
  expect_identical(a, 3L, label = "[modified R object]")
  expect_warning(eval(expr), "[dotCall64|wrong R object type]",
                 label = "[dotCall64|wrong R object type]")

  expr <- expression(.C64("TEST_prod_double",
                          c("double", "double"),
                          a = a, b = 2L,
                          INTENT = c("r", "rw"),
                          PACKAGE = "dotCall64",
                          VERBOSE = 2))
  expect_warning(eval(expr),
                 "alloc 0; coerce 1; dup 0;\ncast.in 0; cast.back 0")
})

library(dotCall64)
context("test-local-tests")

test_that("pass-long-int64_t", {
    skip_on_cran()

    # Ideally, the following should be tested with N <- 31. Blows my laptop...
    N <- 31
    N <- 21
    
    a <- numeric(2^N)
   
    expect_identical(.C64("BENCHMARK",
                          SIGNATURE = "int64",
                          a = a,
                          INTENT = "rw",
                          NAOK = TRUE,
                          VERBOSE = 1,
                          PACKAGE = "dotCall64")$a,
                     a)
})

#' Allocate vectors in .C64()
#'
#' \code{vector_dc} and its shortcuts \code{numeric_dc} and
#' \code{integer_dc} are helper functions used in calls to \code{\link{.C64}}.
#' They return an R object of class \code{c("vector_dc", "list")}, 
#' which contains information on the type and length of the vector to allocate.
#' Using \code{vector_dc} together with \code{INTENT = "w"} argument of \code{\link{.C64}}
#' leads to performance gains by avoiding unnecessary castings and copies. 
#'
#' @param mode character vector of length 1. Storage mode of the vector.
#' @param length numeric vector of length 1. Length of the vector.
#' @return object of class \code{vector_dc} and \code{list}.
#' @name vector_dc
#' @rdname vector_dc
#' @examples
#' vector_dc("integer", 20)
#' @export
vector_dc <- function(mode = "logical", length = 0L) {
	r <- list(mode = as.character(mode),
                  length = as.numeric(length))
        class(r) <- c("vector_dc", "list")
        r
    }

#' @name numeric_dc
#' @rdname vector_dc
#' @export
numeric_dc <- function(length = 0) vector_dc(mode = "numeric", length = length)

#' @name integer_dc
#' @rdname vector_dc
#' @export
integer_dc <- function(length = 0) vector_dc(mode = "integer", length = length)

context("test-vector_dc")

test_that("int", {
   expr <- expression(
         .C64("TEST_times2_int", c("int", "int"),
              a = 2L, r = integer(1),
              INTENT = c("rw", "w"),
              PACKAGE = "dotCall64",
              VERBOSE = 1))
  expr_list <- expression(
         .C64("TEST_times2_int", c("int", "int"),
              a = 2L, r = list(mode = "integer", length = 1L),
              INTENT = c("rw", "w"),
              PACKAGE = "dotCall64",
              VERBOSE = 1))
  expr_dc <- expression(
         .C64("TEST_times2_int", c("int", "int"),
              a = 2L, r = integer_dc(1),
              INTENT = c("rw", "w"),
              PACKAGE = "dotCall64",
              VERBOSE = 1))

  ## warnings
  expect_warning(eval(expr), "[dotCall64|referenced 'w' argument]",
                 label = "[dotCall64|referenced 'w' argument]")
  expect_warning(eval(expr_list), "[dotCall64|referenced 'w' argument]",
                 label = "[dotCall64|referenced 'w' argument]")
  expect_warning(eval(expr_list),
                 "[dotCall64|referenced 'w' argument]",
                 label = "[dotCall64|referenced 'w' argument]")
  expect_silent(eval(expr_dc))
})


test_that("numeric", {
   expr <- expression(
         .C64("TEST_times2_double", c("double", "double"),
              a = 2, r = numeric(1),
              INTENT = c("rw", "w"),
              PACKAGE = "dotCall64",
              VERBOSE = 1))
  expr_list <- expression(
         .C64("TEST_times2_double", c("double", "double"),
              a = 2, r = list(mode = "integer", length = 1L),
              INTENT = c("rw", "w"),
              PACKAGE = "dotCall64",
              VERBOSE = 1))
  expr_dc <- expression(
         .C64("TEST_times2_double", c("double", "double"),
              a = 2, r = numeric_dc(1),
              INTENT = c("rw", "w"),
              PACKAGE = "dotCall64",
              VERBOSE = 1))
  ## warnings
  expect_warning(eval(expr), "[dotCall64|referenced 'w' argument]",
                 label = "[dotCall64|referenced 'w' argument]")
  expect_warning(eval(expr_list), "[dotCall64|referenced 'w' argument]",
                 label = "[dotCall64|referenced 'w' argument]")
  expect_warning(eval(expr_list),
                 "[dotCall64|referenced 'w' argument]",
                 label = "[dotCall64|referenced 'w' argument]")
  expect_silent(eval(expr_dc))
})


test_that("wrong type", {
   expr <- expression(
         .C64("TEST_times2_double", c("double", "double"),
              a = 2L, r = character(1),
              INTENT = c("rw", "w"),
              PACKAGE = "dotCall64",
              VERBOSE = 1))
  expr_list <- expression(
         .C64("TEST_times2_double", c("double", "double"),
              a = 2L, r = list(mode = "character", length = 1L),
              INTENT = c("rw", "w"),
              PACKAGE = "dotCall64",
              VERBOSE = 1))
  expr_dc <- expression(
         .C64("TEST_times2_double", c("double", "double"),
              a = 2L, r = vector_dc("character", 1L),
              INTENT = c("rw", "w"),
              PACKAGE = "dotCall64",
              VERBOSE = 1))

  ## warnings
  expect_warning(eval(expr), "[dotCall64|referenced 'w' argument]",
                 label = "[dotCall64|referenced 'w' argument]")
  expect_warning(eval(expr), "[dotCall64|wrong R object type]",
                 label = "[dotCall64|wrong R object type]")

  expect_warning(eval(expr_list), "[dotCall64|referenced 'w' argument]",
                 label = "[dotCall64|referenced 'w' argument]")
  expect_warning(eval(expr_list), "[dotCall64|wrong R object type]",
                 label = "[dotCall64|wrong R object type]")

  expect_error(eval(expr_dc),
                 "not yet supported by allocInitializedVector",
               label = "[error allocInitializedVector]")
})

context("test-flow-right")

## test right side of flow chart
## consider the 'r' variable
intent <- c("r", "w")
tg <- expand.grid(signature = c("int", "double", "int64"),
            type = c("int", "double"),
            referenced = c("ref", "notRef"),
            stringsAsFactors = FALSE)

for(i in 1:nrow(tg)){
test_that(paste0("right-", paste0(tg[i,], collapse = "-")), {
    signature <- tg[i, "signature"]
    type <- tg[i, "type"]
    referenced <- if(tg[i, "referenced"] == "ref") TRUE else FALSE
    info <- paste0("signature:", signature,
                   ", type:", type, ", i:", i)

    a <- switch(type,
                int = 5L,
                double = 7.6,
                int64 = 2^32)

    if(referenced){
       b <- switch(type,
                   int = 1L,
                   double = 1.0,
                   int64 = 1.0)
    } else
       b <- switch(type,
                    int = integer_dc(1),
                    double = numeric_dc(1),
                    int64 = numeric_dc(1))
      
    expr <- expression(
          .C64(paste0("TEST_times2_", signature),
               c(signature, signature),
               a = a,
               r = b,
               INTENT = intent,
               PACKAGE = "dotCall64",
               VERBOSE = 1))

    dc <- suppressWarnings(eval(expr))
    a_out <- if(signature %in% c("int", "int64")) as.integer(a) else a
    r_out <- 2L * a_out
    ## currently returned objects are of type "signature"
    r_out <- if(signature == "int") as.integer(r_out) else as.double(r_out)
    dc_e <- list(a = NULL, r =  r_out)
    expect_equal(dc, dc_e,
                 info = info)
    expect_equal(typeof(dc$r), typeof(dc_e$r),
                 info = info)

    ## test for corrupted R objects
    expect_identical(a, switch(type,
                               int = 5L,
                               double = 7.6,
                               int64 = 2^32),
                     label = "[corrupt R object]",
                     info = info)
 
    if(referenced)
      expect_identical(b, switch(type,
                                 int = 1L,
                                 double = 1.0,
                                 int64 = 1.0),
                      label = "[corrupt R object]",
                      info = info)


    ## test warnings
    if(referenced){
      expect_warning(eval(expr),
                     "[dotCall64|referenced R object]",
                     label = "[dotCall64|referenced R object]",
                     info = info)
    } else {
      ## expect_that(eval(expr),
      ##             not(gives_warning("[dotCall64|referenced R object]")),
      ##             label = "[dotCall64|referenced R object]",
      ##             info = info)
    }


    if(signature != type && !(signature == "int64" && type == "double")) {
       expect_warning(eval(expr), "[dotCall64|wrong R object type]",
                      info = info,
                      label = "[dotCall64|wrong R object type]")
   } else {
       ## expect_that(eval(expr),
       ##             not(gives_warning("[dotCall64|wrong R object type]")),
       ##             info = info)
   }
})
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vector_dc.R
\name{vector_dc}
\alias{vector_dc}
\alias{numeric_dc}
\alias{integer_dc}
\title{Allocate vectors in .C64()}
\usage{
vector_dc(mode = "logical", length = 0L)

numeric_dc(length = 0)

integer_dc(length = 0)
}
\arguments{
\item{mode}{character vector of length 1. Storage mode of the vector.}

\item{length}{numeric vector of length 1. Length of the vector.}
}
\value{
object of class \code{vector_dc} and \code{list}.
}
\description{
\code{vector_dc} and its shortcuts \code{numeric_dc} and
\code{integer_dc} are helper functions used in calls to \code{\link{.C64}}.
They return an R object of class \code{c("vector_dc", "list")}, 
which contains information on the type and length of the vector to allocate.
Using \code{vector_dc} together with \code{INTENT = "w"} argument of \code{\link{.C64}}
leads to performance gains by avoiding unnecessary castings and copies.
}
\examples{
vector_dc("integer", 20)
}
